#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.ComponentModel;
using System.Runtime.Serialization;
using System.Windows.Forms;

using Syncfusion.Windows.Forms.Diagram;

namespace ControlsGalore
{
	/// <summary>
	/// Summary description for MySymbol.
	/// </summary>
	[Serializable()]
	public class TreeViewSymbol : Symbol
	{
		private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
		private Syncfusion.Windows.Forms.Diagram.ControlNode ctrlNode = null;

		public TreeViewSymbol()
		{
			//////////////////////////////////////////////////////////////////
			// Add child nodes to the symbol programmatically
			//////////////////////////////////////////////////////////////////

			// Add an outer rectangle
			this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 200, 120);
			this.outerRect.Name = "Rectangle";
			this.outerRect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.outerRect.FillStyle.ForeColor = System.Drawing.Color.Orange;
			this.outerRect.FillStyle.Color = Color.Orange;
			this.AppendChild(this.outerRect);

			// Add the inner ControlNode containing a Windows Forms TreeView control
			this.ctrlNode = new ControlNode(new RectangleF(10, 10, 180, 100));
			this.ctrlNode.ControlAssemblyName = "System.Windows.Forms";
			this.ctrlNode.ControlClassName = "System.Windows.Forms.ComboBox";
			this.ctrlNode.Name = "InnerTree";			

			// Create and initialize the node's treeview control
			this.ctrlNode.CreateControl();
            this.PopulateDropdownListControl(this.ctrlNode.Control as ComboBox);
            //this.PopulateTreeView(this.ctrlNode.Control as TreeView);		

			this.ctrlNode.ActivateControl();
			this.AppendChild(this.ctrlNode);
			
		}		

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected TreeViewSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{		
		}		
		
		/// <summary>
		/// Called when deserialization is complete.
		/// </summary>
		/// <param name="sender">Object performing the deserialization</param>
//		protected override void OnDeserialization(object sender)
//		{
//			base.OnDeserialization(sender);
//
//			// Get the TreeView control hosted in the Symbol's ControlNode child and populate the TreeView data
//			foreach(INode node in this.children)
//			{
//				if(node is ControlNode)
//				{
//					ControlNode ctrlnode = node as ControlNode;
//                 //   this.PopulateDropdownListControl(ctrlNode.Control as ComboBox);				    
//                    //this.PopulateTreeView(ctrlnode.Control as TreeView);
//				}
//			}					
//		}
		
	    protected void PopulateDropdownListControl(ComboBox comboBox)
	    {
            comboBox.Items.Add("Raja");
            comboBox.Items.Add("Ravi");
            comboBox.Items.Add("Ramesh");
            comboBox.Items.Add("Krishna");
	    }
	    
		// Populate the TreeView control hosted in the Symbol's ControlNode
        //protected void PopulateTreeView(TreeView treectrl)
        //{
        //    treectrl.Nodes.AddRange(new System.Windows.Forms.TreeNode[] {
        //                                                                    new System.Windows.Forms.TreeNode("QuickSolutions", 7, 7, new System.Windows.Forms.TreeNode[] {
        //                                                                                                                                                                      new System.Windows.Forms.TreeNode("Solution 1", 3, 3),
        //                                                                                                                                                                      new System.Windows.Forms.TreeNode("Solution 2", 4, 4),
        //                                                                                                                                                                      new System.Windows.Forms.TreeNode("Trial", 5, 5),
        //                                                                                                                                                                      new System.Windows.Forms.TreeNode("Clerks", 5, 5),
        //                                                                                                                                                                      new System.Windows.Forms.TreeNode("WorkIssue", 6, 6)}),
        //                                                                    new System.Windows.Forms.TreeNode("BG Group", 4, 4, new System.Windows.Forms.TreeNode[] {
        //                                                                                                                                                                new System.Windows.Forms.TreeNode("Office1", 4, 4, new System.Windows.Forms.TreeNode[] {
        //                                                                                                                                                                                                                                                           new System.Windows.Forms.TreeNode("Clients")})}),
        //                                                                    new System.Windows.Forms.TreeNode("XYZ Org", 8, 8, new System.Windows.Forms.TreeNode[] {
        //                                                                                                                                                               new System.Windows.Forms.TreeNode("Contacts", 3, 3),
        //                                                                                                                                                               new System.Windows.Forms.TreeNode("Referrals")}),
        //                                                                    new System.Windows.Forms.TreeNode("XYZ Sales", 5, 5),
        //                                                                    new System.Windows.Forms.TreeNode("BetaSoft", 7, 7),
        //                                                                    new System.Windows.Forms.TreeNode("MicroCorp", 6, 6, new System.Windows.Forms.TreeNode[] {
        //                                                                                                                                                                 new System.Windows.Forms.TreeNode("Sales 1", 6, 6),
        //                                                                                                                                                                 new System.Windows.Forms.TreeNode("Sales 2", 6, 6),
        //                                                                                                                                                                 new System.Windows.Forms.TreeNode("Complaints", 4, 4)})});

        //}
	}
}
